"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
function toCommonLogFormat(request) {
    var rawReq = request.raw.req;
    var method = rawReq.method;
    var path = rawReq.url;
    var httpProtocol = rawReq["client"]
        ? rawReq["client"].npnProtocol
        : 'HTTP/' + rawReq.httpVersion;
    var clientIp = request.info.remoteAddress;
    var clientId = '-';
    var userid = request.id;
    var time = '[' + moment().toISOString() + ']';
    var requestLine = '"' + [method, path, httpProtocol].join(' ') + '"';
    var statusCode = request.response.statusCode;
    var objectSize = '-';
    return [
        clientIp,
        clientId,
        userid,
        time,
        requestLine,
        statusCode,
        objectSize
    ].join(' ');
}
exports.toCommonLogFormat = toCommonLogFormat;
;
//# sourceMappingURL=CommonLogFormatter.js.map