import * as Hapi from "hapi";
import { App } from "protoculture";
import { Route, ActionRoute, DirectoryRoute, FileRoute } from "./Route";
export declare class Dispatcher {
    protected app: App;
    protected server: Hapi.Server;
    constructor(app: App, server: Hapi.Server);
    registerRoutes(routes: Route[]): void;
    registerRoute(route: Route | Hapi.RouteConfiguration): void;
    protected registerActionRoute(route: ActionRoute): void;
    protected registerDirectoryRoute(route: DirectoryRoute): void;
    protected registerFileRoute(route: FileRoute): void;
    protected registerHapiRoute(route: Hapi.RouteConfiguration): void;
    protected dispatch(request: Hapi.Request, reply: Hapi.Base_Reply, route: ActionRoute): Promise<void>;
    protected error(error: any, request: Hapi.Request, reply: Hapi.Base_Reply, route: Route): void;
}
