import * as Hapi from "hapi";
import { App, Suite, LogLevel } from "protoculture";
import { Dispatcher } from "./Dispatcher";
import { Route } from "./Route";
export declare class HapiApp implements App {
    protected server: Hapi.Server;
    protected routes: Route[];
    readonly name: string;
    readonly working: boolean;
    suite: Suite;
    protected dispatcher: Dispatcher;
    constructor(server: Hapi.Server, routes: Route[]);
    run(): Promise<void>;
    protected logRequest(request: Hapi.Request, event: Event): void;
    protected logResponse(request: Hapi.Request): void;
    protected logError(request: Hapi.Request, error: Error): void;
    protected log(message: any, level?: LogLevel): void;
}
