"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var protoculture_1 = require("protoculture");
var Dispatcher_1 = require("./Dispatcher");
var CommonLogFormatter_1 = require("./CommonLogFormatter");
var HapiApp = (function () {
    function HapiApp(server, routes) {
        var _this = this;
        this.server = server;
        this.routes = routes;
        this.dispatcher = new Dispatcher_1.Dispatcher(this, this.server);
        this.server.on("log", function (request, event) { return _this.log(event, protoculture_1.LogLevel.Info); });
        this.server.on("request-error", function (request, error) { return _this.logError(request, error); });
        this.server.on("request", function (request, event) { return _this.logRequest(request, event); });
        this.server.on("response", function (request) { return _this.logResponse(request); });
        this.dispatcher.registerRoutes(this.routes);
    }
    Object.defineProperty(HapiApp.prototype, "name", {
        get: function () {
            return "hapi";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HapiApp.prototype, "working", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    HapiApp.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var connections;
            return __generator(this, function (_a) {
                connections = _.map(this.server.connections, function (connection) {
                    return " - " + connection.info.host + ":" + connection.info.port;
                });
                this.log("Listening via: \n" + connections.join("\n"));
                this.server.start();
                return [2];
            });
        });
    };
    HapiApp.prototype.logRequest = function (request, event) {
        this.log(event, protoculture_1.LogLevel.Info);
    };
    HapiApp.prototype.logResponse = function (request) {
        this.log(CommonLogFormatter_1.toCommonLogFormat(request), protoculture_1.LogLevel.Info);
    };
    HapiApp.prototype.logError = function (request, error) {
        this.log(error, protoculture_1.LogLevel.Error);
    };
    HapiApp.prototype.log = function (message, level) {
        this.suite.logger.log(message, this, level);
    };
    return HapiApp;
}());
exports.HapiApp = HapiApp;
//# sourceMappingURL=HapiApp.js.map